// ===============================================================================================
package gamelib;

import javax.swing.JOptionPane;
import java.util.Calendar;
import java.io.*;
// -----------------------------------------------------------------------------

public class hiscore {

  final int snamlen = 24;
  String hscfile, geschafft, bedauern;
  int himax;
  int punkte[];
  String sname[];
  String datum[];
  loadsave fh = new loadsave();

// Konstruktor und Methoden: ---------------------------------------------------------------------------------
  public hiscore(String outfil, String ges, String nichtges, int anz) {
    himax = anz;
    punkte = new int[himax + 1];
    sname = new String[himax + 1];
    datum = new String[himax + 1];
    hscfile = outfil;
    load_hsc();
    geschafft = ges;
    bedauern = nichtges;
  }

  public int get_len() {
    return himax;
  }

  public String get_snamen(int platz) {
    return sname[platz];
  }

  public int get_punkte(int platz) {
    return punkte[platz];
  }

  public String get_datum(int platz) {
    return datum[platz];
  }

  public void reset_hsc() {
    String out = "", dat = get_datum();
    for (int i = 0; i < himax; i++) {
      out = out + "0;" + dat + ";...\n";
    }
    fh.savefile(hscfile, out);
    load_hsc();
  }

  public void eintrag(int pkt) {
    load_hsc(); // safety first! Hier darf kein Puffer stoeren!
    if (pkt > punkte[himax - 1]) {
      sname[himax] = JOptionPane.showInputDialog(pkt+geschafft);
      if (sname[himax] != null) {
        if (sname[himax].length() > 0) {
          if (sname[himax].length() > snamlen) {
            sname[himax] = sname[himax].substring(0, snamlen);
          }
          punkte[himax] = pkt;
          datum[himax] = get_datum();
          bubblesort();
          save_hsc();
        }
      }
    } else {
      JOptionPane.showMessageDialog(null, "" + pkt + bedauern, "Info:", JOptionPane.INFORMATION_MESSAGE);
    }
    load_hsc();
  }

// ===========================================================================================================
  void load_hsc() {
    String rec[] = fh.get_lines(hscfile);
    String temp[] = new String[3];
    if (rec.length <=himax) {
      for (int i = 0; i < rec.length; i++) {
        temp = rec[i].split(";");
        punkte[i] = Integer.parseInt(temp[0]);
        datum[i] = temp[1];
        sname[i] = temp[2];
      }
    }
  }

  void save_hsc() {
    String out = "";
    bubblesort();
    for (int i = 0; i < himax; i++) {
      out = out + punkte[i] + ";" + datum[i] + ";" + sname[i] + "\n";
    }
    fh.savefile(hscfile, out);
  }

  void bubblesort() {
    int i, j, k;
    String s;
    boolean tau;
    for (i = 0; i < himax; i++) {
      do {
        tau = false;
        for (j = i + 1; j <= himax; j++) {
          if (punkte[i] < punkte[j]) {
            tau = true;
            k = punkte[i];
            punkte[i] = punkte[j];
            punkte[j] = k;
            s = datum[i];
            datum[i] = datum[j];
            datum[j] = s;
            s = sname[i];
            sname[i] = sname[j];
            sname[j] = s;
          }
        }
      } while (tau);
    }
  }

  String get_datum() {
    Calendar cal = Calendar.getInstance();
    String t = "";
    int t1 = cal.get(Calendar.DATE);
    if (t1 < 10) {
      t = t + "0";
    }
    t = t + t1 + ".";
    t1 = cal.get(Calendar.MONTH) + 1;
    if (t1 < 10) {
      t = t + "0";
    }
    t = t + t1 + ".";
    t1 = cal.get(Calendar.YEAR) % 100;
    if (t1 < 10) {
      t = t + "0";
    }
    t = t + t1 + " ";
    t1 = cal.get(Calendar.HOUR_OF_DAY);
    if (t1 < 10) {
      t = t + "0";
    }
    t = t + t1 + ":";
    t1 = cal.get(Calendar.MINUTE);
    if (t1 < 10) {
      t = t + "0";
    }
    t = t + t1 + ":";
    t1 = cal.get(Calendar.SECOND);
    if (t1 < 10) {
      t = t + "0";
    }
    t = t + t1;
    return t;
  }
}
