package hexentanz;

/**
 *
 * @author ujaso
 *
 * Version 1.1:
 * Hexen kommen von den Seiten herein, jede bewegt sich mindestens etwas
 * neuer Set Bilder für Screenbreite 800 und kleiner (schärfer gerendert)
 * Menus auf Titelbild klicksensitiv gemacht
 * Druckfehler im Titelbild korrigiert
 * Headers in Bestenliste zugefügt, Bestenliste verschönt
 * Anzeigen im Spiel ausgearbeitet
 * 
 * 
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Hashtable;
import gamelib.*;
import javax.swing.JRadioButtonMenuItem; // Sprache, xmax
import javax.swing.JCheckBoxMenuItem;    // Sound, Mucke

// -----------------------------------------------------------------------------

public class main extends JPanel
{
  final static String gname="Hexentanz",kenn="hexentanz";
  final static String datenpfad="/"+kenn+"/data/";
  final static String soundpfad="/"+kenn+"/sounds/";

  final static String commands[]  = { "neu","pause","quit","hiscore","hireset","hilfe","about","cont", "sound","music",
  "size","lang","saveopt","deutsch","englisch","s0","s1","s2","s3" };
  final static String hscfile   ="hiscore.csv";
  final static String configfile="game.ini";
  final static String waves[]  = { "Schatzwalzer.wav","gefunden.wav","daneben.wav" };

  static String lang;         // Language kennung, derzeit en oder deu
  static String langtext[];   // Textkennungen
  static Hashtable<String,String> langdef=new Hashtable<String,String>();

  static loadsave fh0=new loadsave();
  static String[] hilfetext;
  static hiscore hsc;

  static int kommando=-1;
  static int soundon,muckeon;
  static int xmax=800,ymax=400;

  static JMenuItem menu01; // Pausentoggle: da muessen mer ran!
  static JCheckBoxMenuItem menu30; // Sound on/off
  static JCheckBoxMenuItem menu31; // Mucke on/off
  static ButtonGroup menu32;
  static ButtonGroup menu33;
  static JRadioButtonMenuItem jmi_lang[];
  static JRadioButtonMenuItem jmi_size[];

  static main steuerung;
  static spielfeld gamepanel;
  static spiel     game      =new spiel();
  static sound     zaund     =new sound(soundpfad,waves);

  static ActionListener alist=new ActionListener()            { public void actionPerformed(ActionEvent e) { buttonklick(e); } };
  static MouseAdapter mausdap=new MouseAdapter()              { public void mousePressed(MouseEvent e)     { klick(e.getX(),e.getY()); } };
  static MouseMotionAdapter mausdapm=new MouseMotionAdapter() { public void mouseMoved(MouseEvent e)       { mausover(e.getX(),e.getY()); } };

  // nicht threadsicher, daher diese Konstruktion, sonst vergist JIT u.U. die Hälfte
  public static void main(String[] args)
  { javax.swing.SwingUtilities.invokeLater(new Runnable() { public void run()
    { mach_hinne();
    } } );
  }

  static void mach_hinne()
  { load_config();
    gamepanel=new spielfeld(xmax);

    hilfetext=fh0.get_ressourcelines(datenpfad+"hilfe_"+lang+".txt");
    hsc=new hiscore(hscfile,langdef.get("EINTRAG"),langdef.get("ZU_WENIG"),10);
    init_gui();

  }

  public static String get_kennung()     { return kenn; }
  public static String get_spielname()   { return gname; }
  public static int get_xmax() { return xmax; }
  public static int get_ymax() { return ymax; }
// ----------------------------------------------------------------------------------------------------------------
  // ini-Files lesen und auswerten ----------------------------------------------------------
  static void load_config()
  { int i;
    String t;
    String temp[]=new String[2];
    String rec[]=fh0.get_lines(configfile);
    lang="deu";
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split("=");
      if (temp.length>1) t=temp[1]; else t="0";
      if (temp[0].equals("soundon")) soundon=Integer.parseInt(t);
      else if (temp[0].equals("musicon")) muckeon=Integer.parseInt(t);
      else if (temp[0].equals("size")) xmax=Integer.parseInt(t);
      else if (temp[0].equals("lang")) lang=t;
    }
    rec=fh0.get_ressourcelines(datenpfad+"lang_"+lang+".def");
    for (i=0; i<rec.length; i++)
    { temp=rec[i].split("=");
      langdef.put(temp[0],temp[1]);
    }
 }

  static void init_gui()
  { JPanel mama=new JPanel(new BorderLayout());
    mama.add(gamepanel);
    gamepanel.set_size(xmax);
    gamepanel.addMouseListener(mausdap);
    gamepanel.addMouseMotionListener(mausdapm);
    
    JFrame frame=new JFrame(gname);
    JMenuBar my_menu=mach_menubar();
    if (soundon>0) sound_on(); else sound_off();
    if (muckeon>0) mucke_on(); else mucke_off();
    show_opts();
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    // frame.setIconImage(Toolkit.getDefaultToolkit().getImage("icon.gif"));
    frame.setJMenuBar(my_menu);
    frame.setContentPane(mama);
    frame.setSize(xmax,5*xmax/8);
    frame.setVisible(true);
  }

  static JMenuBar mach_menubar()
  { int i;
    JMenuBar menu=new JMenuBar();
    menu.setLayout(new FlowLayout(FlowLayout.LEFT,32,0));
    // Dropdown Menus Headers:
    JMenu menu0=new JMenu(langdef.get("TITLE")); menu0.setMnemonic(KeyEvent.VK_0); menu.add(menu0);
    JMenu menu3=new JMenu(langdef.get("OPTIONS")); menu3.setMnemonic(KeyEvent.VK_2); menu.add(menu3);
    JMenu menu1=new JMenu(langdef.get("HISCORE")); menu1.setMnemonic(KeyEvent.VK_1); menu.add(menu1);
    JMenu menu2=new JMenu(langdef.get("INFO"));    menu2.setMnemonic(KeyEvent.VK_3); menu.add(menu2);

    // Dropdown Menu 0:
    // neu:
    JMenuItem menu00 = new JMenuItem(langdef.get("NEW"),KeyEvent.VK_N);
    menu00.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,InputEvent.CTRL_MASK));
    menu00.addActionListener(alist);
    menu00.setActionCommand(commands[0]);
    menu0.add(menu00);
    // Pause/weiter:
    menu01 = new JMenuItem(langdef.get("PAUSE"),KeyEvent.VK_P);
    menu01.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,InputEvent.CTRL_MASK));
    menu01.setActionCommand(commands[1]);
    menu01.addActionListener(alist);
    menu0.add(menu01);
    // Quit:
    JMenuItem menu02 = new JMenuItem(langdef.get("QUIT"),KeyEvent.VK_Q);
    menu02.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Q,InputEvent.CTRL_MASK));
    menu02.addActionListener(alist);
    menu02.setActionCommand(commands[2]);
    menu0.add(menu02);

    // Dropdown-Menu Options
    // Sound on/off: Toggle
    menu30 = new JCheckBoxMenuItem(langdef.get("SOUND"));
    menu30.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.CTRL_MASK));
    menu30.setActionCommand(commands[8]);
    menu30.addActionListener(alist);
    menu3.add(menu30);
    // Mucke on/off: Toggle
    menu31 = new JCheckBoxMenuItem(langdef.get("MUSIC"));
    menu31.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M,InputEvent.CTRL_MASK));
    menu31.setActionCommand(commands[9]);
    menu31.addActionListener(alist);
    menu3.add(menu31);

    menu3.addSeparator();
    menu3.add(langdef.get("SIZE"));
    // Radiobutts size und lang:
    menu32=new ButtonGroup();
    jmi_size=new JRadioButtonMenuItem[4];
    jmi_size[0]=new JRadioButtonMenuItem(" 800px");
    jmi_size[1]=new JRadioButtonMenuItem("1024px");
    jmi_size[2]=new JRadioButtonMenuItem("1200px");
    jmi_size[3]=new JRadioButtonMenuItem("1600px");
    for (i=0; i<jmi_size.length; i++)
    { jmi_size[i].addActionListener(alist);
      jmi_size[i].setActionCommand(commands[15+i]);
      menu32.add(jmi_size[i]);
      menu3.add(jmi_size[i]);
    }
    menu3.addSeparator();

    menu3.add(langdef.get("LANG"));
    menu33=new ButtonGroup();
    jmi_lang=new JRadioButtonMenuItem[2];
    jmi_lang[0]=new JRadioButtonMenuItem(langdef.get("DEU"));
    jmi_lang[1]=new JRadioButtonMenuItem(langdef.get("ENG"));
    for (i=0; i<jmi_lang.length; i++)
    { jmi_lang[i].addActionListener(alist);
      jmi_lang[i].setActionCommand(commands[13+i]);
      menu33.add(jmi_lang[i]);
      menu3.add(jmi_lang[i]);
    }
    menu3.addSeparator();

    JMenuItem menu34 = new JMenuItem(langdef.get("SAVEOPT"),KeyEvent.VK_S);
    menu34.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.CTRL_MASK));
    menu34.setActionCommand(commands[12]);
    menu34.addActionListener(alist);
    menu3.add(menu34);

    // Dropdown Menu 1:
    // zeige Bestenliste:
    JMenuItem menu10 = new JMenuItem(langdef.get("SHOWHSC"),KeyEvent.VK_B);
    menu10.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_B,InputEvent.CTRL_MASK));
    menu10.setActionCommand(commands[3]);
    menu10.addActionListener(alist);
    menu1.add(menu10);
    // Reset HSC:
    JMenuItem menu11 = new JMenuItem(langdef.get("HIRESET"),KeyEvent.VK_R);
    menu11.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,InputEvent.CTRL_MASK));
    menu11.setActionCommand(commands[4]);
    menu11.addActionListener(alist);
    menu1.add(menu11);

    // Dropdown Menu 2: Infos
    JMenuItem menu20 = new JMenuItem(langdef.get("HELP"),KeyEvent.VK_H);
    menu20.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,InputEvent.CTRL_MASK));
    menu20.setActionCommand(commands[5]);
    menu20.addActionListener(alist);
    menu2.add(menu20);
    JMenuItem menu21 = new JMenuItem(langdef.get("ABOUT"),KeyEvent.VK_A);
    menu21.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,InputEvent.CTRL_MASK));
    menu21.setActionCommand(commands[6]);
    menu21.addActionListener(alist);
    menu2.add(menu21);
    
    return menu;
  }
// ===========================================================================================================
// Sender fuer kommando,aktscreen
  static public void buttonklick(ActionEvent e)
  { kommando=-1;
    for (int i=0; i<commands.length; i++) if (commands[i] .equals(e.getActionCommand())) kommando=i;
    switch(kommando)
    { case 0: neu(); break;
      case 1: if (game.spiel_laeuft) { if (game.get_paused()) weiter(); else pause(); } break;
      case 2: System.exit(0); break;
      case 3: show_hsc(); break;
      case 4: hsc.reset_hsc(); show_hsc(); break;
      case 5: show_hilfe(); break;
      case 6: show_info(); break;
      case 7: cont(); break;
      case 8: if ( soundon>0) sound_off(); else sound_on(); break;
      case 9: if ( muckeon>0) mucke_off(); else mucke_on(); break;
      case 12: save_opt(); break;
      case 13: lang="deu"; show_opts(); break;
      case 14: lang="eng"; show_opts(); break;
      case 15: xmax=800; show_opts(); break;
      case 16: xmax=1024; show_opts(); break;
      case 17: xmax=1200; show_opts(); break;
      case 18: xmax=1600; show_opts(); break;
    }
  }

  // Aktionen:
  static void popup(String t) { JOptionPane.showMessageDialog(steuerung,t,"Info:",JOptionPane.INFORMATION_MESSAGE); }
  static void show_titel()    { gamepanel.set_screen("titel"); }
  static void neu()           { game.neu(); gamepanel.set_screen("play"); }
  static void cont()          { if (!game.spiel_laeuft) game.neu(); gamepanel.set_screen("play"); }
  static void show_hilfe()    { pause(); gamepanel.set_screen("help"); }
  
  static void show_info()     { String out=langdef.get("TITLE")+" by uja - V.1.1\n gamelib by uja - V1.1"; out=out+"\nJava Version "+System.getProperty("java.version"); popup(out); }
  static void show_hsc()      { pause(); for (int i=0; i<hsc.get_len(); i++) { hsc.get_snamen(i); hsc.get_punkte(i);hsc.get_datum(i); } gamepanel.set_screen("hiscore"); }
  static void mausover(int mx,int my) { game.hover(mx,my); }
  static void aufraeumen()            { zaund.close_soundall(); System.exit(0); }
  static void klick(int mx,int my)
  { if (gamepanel.get_screen().equals("play")) game.klick(mx,my);
    else if (gamepanel.get_screen().equals("titel")) game.startauswerten(mx,my);
  }
  static void sound_off() { soundon=0; show_opts(); }
  static void sound_on()  { soundon=1; show_opts(); }
  static void mucke_off() { game.set_mucke(false); muckeon=0; show_opts(); }
  static void mucke_on()  { game.set_mucke(true);  muckeon=1; show_opts(); }
  static void pause()     { game.set_pause(true);  menu01.setText(langdef.get("CONT")); }
  static void weiter()    { game.set_pause(false); menu01.setText(langdef.get("PAUSE")); gamepanel.set_screen("play"); }

  static void show_opts()
  { int k;
    menu30.setState(soundon>0);
    menu31.setState(muckeon>0);
    menu32.clearSelection();
    switch(xmax)
    { case 800: k=0; break;
      case 1024: k=1; break;
      case 1200: k=2; break;
      case 1600: k=3; break;
      default: k=-1;
    }
    if (k>=0) jmi_size[k].setSelected(true);
    menu33.clearSelection();
    if (lang.equals("deu")) k=0;
    else if (lang.equals("eng")) k=1;
    else k=-1;
    if (k>=0) jmi_lang[k].setSelected(true);
  }

  static void save_opt()
  { String[] t=new String[4];
    loadsave fh=new loadsave();
    t[0]="soundon="+soundon;
    t[1]="musicon="+muckeon;
    t[2]="size="+xmax;
    t[3]="lang="+lang;
    fh.set_file("game.ini",t);
    popup(langdef.get("OPTSAVED"));
  }
}


