package hexentanz;
import java.util.Random;
import gamelib.*;

/**
Threadgesteuertes Spiel der Klasse Wimmelbild mit Halloween-Motiven,
Highscoreliste und Pausenfunktion.
Die Framerate wird aus der Klasse spielfeld uebernommen.

@author uja
@version 20101015
@see gamelib.sprite
@see spielfeld
*/

class spiel implements Runnable
{
  static final int numhexen=48,numtypen=45,numgeister=24;
  static final int maxsprites=numhexen+numgeister+1; // maximale Anzahl Objekte

  Thread mainloop;
  static int weitermit=0,punkte=0,zeit=90,gewaehlt=1,num=8,blitz_on=0; // ein paar Parameter
  static long tic;
  static boolean gover,pausiert,soundon,muckeon,spiel_laeuft=false; // ein paar Flags
  static String messi="";
  static sprite[] sprit=new sprite[maxsprites];
  static int[] liste=new int[maxsprites];
  static int[] haeufigkeit=new int[numtypen+1];

  // Pointer:
  Random rand=new Random();
  spielfeld p_screen;
  sound p_zaund;
  static int sxmax,timetic,cps;

  public spiel()
  { sxmax=main.xmax;
    timetic=main.gamepanel.timetic;
    cps=1000/timetic;
    p_zaund=main.zaund;
    p_screen=main.gamepanel;
    int i,k=0;
    // Cursor:
    sprit[k]=new sprite(k);
    sprit[k].set_size(32,32);
    sprit[k].set_typ(numtypen+4);
    sprit[k].on();
    k++;
    // Hexen:
    for (i=0; i<numhexen; i++)
    { sprit[k]=new sprite(k);
      sprit[k].set_size(p_screen.dx,p_screen.dy);
      sprit[k].set_typ(i%numtypen+1); // kann variieren
      sprit[k].off();
      k++;
    }
    for (i=0; i<numgeister; i++)
    { sprit[k]=new sprite(i);
      sprit[k].set_size(p_screen.dx,p_screen.dx); // andere Geometrie!
      sprit[k].set_typ(i%3+numtypen+1); // start ab numtypen+1
      sprit[k].off();
      k++;
    }
    for (i=0; i<maxsprites; i++) liste[i]=i;
    pausiert=true;
    gover=false;
    punkte=0; zeit=90; tic=0; gewaehlt=0;
    weitermit=20; // Titelbild zeigen
    mainloop=new Thread(this);
    mainloop.start();
  }

// -------------------------------------------------------------------------------------
// Slots:
// -------------------------------------------------------------------------------------
  public void set_pause(boolean pause)     { pausiert=pause; if (main.muckeon>0) { if (pausiert) main.zaund.stop_sound(0); else main.zaund.cont_sound(0); } }
  public void set_mucke(boolean mit_mucke) { if (mit_mucke) { if (!pausiert) main.zaund.loop_sound(0); } else main.zaund.stop_sound(0); }
  public void set_messi(String t)          { messi=t; }
  public boolean get_paused()              { return pausiert; }

  public void neu()
  { int i;
    weitermit=20; punkte=0; zeit=90; num=8; gover=false; pausiert=false; tic=0;
    for (i=1; i<maxsprites; i++) sprit[i].off();
    for (i=0; i<num; i++) add_hexe();
    set_messi("Happy Finding!");
    spiel_laeuft=true; weitermit=0; gewaehlt=sprit[rand.nextInt(num)+1].typ;
    blitz_on=0;
    if (main.muckeon>0) main.zaund.loop_sound(0);
  }
  
// -------------------------------------------------------------------------------------
// interne Methoden:
// -------------------------------------------------------------------------------------

  public void run()
  { while (mainloop!=null)
    { if (!gover) if (!pausiert) switch (weitermit)
      { case 0: tic++;
                if (tic%cps==0)
                { zeit--;
                  if (zeit<1) weitermit=9;
                  else if (zeit==45) add_geister();
                  else if (zeit%2==0) if (num<numhexen) { num++; add_hexe(); }
                }
                if (blitz_on>0) blitz_on--;
                move_it();
                break;
        case 1: if (soundon) { main.zaund.stop_sound(0); } neu(); weitermit=0; break;
        case 9: gover=true;
                spiel_laeuft=false;
                main.hsc.eintrag(punkte);
                main.show_hsc();
                main.zaund.stop_sound(0);
                weitermit=20;
                break;
        
        case 20: break;                      // Haltepunkt
      }

      try { Thread.sleep(timetic); }
      catch (InterruptedException e) { break; }
    }
  }
  public void stop()    { mainloop=null; }
  public void destroy() { stop(); }

// -------------------------------------------------------------------------------------------------------
// Sprites bewegen, Kollision feststellen, geschossene Goodies auswerten und bei Bedarf Flyer in Kette einhaengen
// return: Platz, den der Flyer in der Kette einnimmt, oder 0, um neuen Flyer zu generieren, sonst -1
  synchronized int move_it()
  { int i;
    for (i=1; i<=numhexen; i++) if (sprit[i].typ>0)
    { if (sprit[i].ix>p_screen.sxmax-p_screen.dx) sprit[i].vx=-Math.abs(sprit[i].vx);
      if (sprit[i].ix<0) sprit[i].vx=Math.abs(sprit[i].vx);
      sprit[i].move();
    }
    for (i=numhexen+1; i<=numhexen+numgeister; i++) if (sprit[i].typ>0)
    { sprit[i].move();
      if (sprit[i].ix>p_screen.sxmax-p_screen.dx) sprit[i].vx=-Math.abs(sprit[i].vx);
      else if (sprit[i].ix<0) sprit[i].vx=Math.abs(sprit[i].vx);
      if (sprit[i].iy>p_screen.sxmax/2-p_screen.dx) sprit[i].vy=-Math.abs(sprit[i].vy);
      else if (sprit[i].iy<0) sprit[i].vy=Math.abs(sprit[i].vy);
    }
    return 0;
  }


// -----------------------------------------------------------------------------------------------------
// diverse Startups:
// -----------------------------------------------------------------------------------------------------
void add_geister()
{ int i,k=numhexen+1;
  for (i=0; i<numgeister; i++)
  { sprit[i+k].set_koords(rand.nextInt(p_screen.sxmax-3*p_screen.dx)+p_screen.dx,rand.nextInt(3*p_screen.dx),k);
    sprit[i+k].set_speed((float)0.2*(rand.nextInt(3)-2),(float)0.2*(rand.nextInt(3)));
    sprit[k+i].set_typ(numtypen+rand.nextInt(3)+1);
    sprit[k+i].on();
  }
}

int freie_hexe() { int i,k=-1; for (i=1; i<=numhexen; i++) if (k<0) if (sprit[i].typ<0) k=i; return k; }
void add_hexe()
{ int i,j,k,ix,iy;
  float r;
  sprite obj;
  int dx=p_screen.dx,dy=p_screen.dy,sxmax=p_screen.sxmax,symax=p_screen.symax,nr=freie_hexe();
  if (nr<1) nr=rand.nextInt(numhexen)+1;
  obj=sprit[nr];
  do
  { // ix=rand.nextInt(sxmax-dx);
    r=(float) 0.05*(rand.nextInt(10)+1);
    if (rand.nextInt(2)<1) { ix=-dx; obj.set_speed(r,0); } else { ix=sxmax; obj.set_speed(-r,0); }
    iy=sxmax/4-dy+rand.nextInt(sxmax/4);
    for (i=1; i<=numhexen; i++) if (sprit[i].id!=nr) if (sprit[i].typ>0) 
     if (Math.abs(sprit[i].get_y()-iy)<dy/4)
       if (Math.abs(sprit[i].vx-obj.vx)<0.1) ix=-2*dx;
  }
  while(ix<-dx);
  obj.set_koords(ix,iy,iy);
  liste=shelsort(1,numhexen);
  // für Abwechslung sorgen: nicht den häufigsten Typ wählen!
  for (i=0; i<=numtypen; i++) haeufigkeit[i]=0;
  for (i=1; i<=numhexen; i++) if (sprit[i].typ>0) haeufigkeit[sprit[i].typ]++;
  k=-1; j=-1; for (i=0; i<=numtypen; i++) if (haeufigkeit[i]>k) { k=haeufigkeit[i]; j=i; }
  k=rand.nextInt(numtypen-1)+1; if (k==j) k=numtypen;
  haeufigkeit[k]++;
  obj.set_typ(k);
  obj.set_speed((float)0.05*(rand.nextInt(10)+1),0);
  obj.on();
}

// sortiert Hexen nach prio
int[] shelsort(int von, int bis)
{ int e,i,delta;
  boolean getauscht;
  double anz=bis-von+1;
  delta=(int)Math.floor(anz/2);
  int ind[]=new int[maxsprites];
  for (i=0; i<maxsprites; i++) ind[i]=i;
  while (delta>0)
  { getauscht=false;
    for (i=1; i<=(anz-delta); i++)
    { if (sprit[ind[i]].iy>sprit[ind[i+delta]].iy)
      { getauscht=true;
        e=ind[i];
        ind[i]=ind[i+delta];
        ind[i+delta]=e;
      }      
    }
    if (!getauscht) delta=(int) Math.floor(delta/2);
  }
  return ind;
}

 // ---------------------------------------------------------------------------------------------------
 //  Steuerung:
 // ---------------------------------------------------------------------------------------------------
void klick(int ix,int iy)
{ if (spiel_laeuft) if (!pausiert)
  { sprit[0].set_koords(ix-16,iy-16,999);
    int i,k=-1;
    int[] tli=new int[numhexen+1]; tli[0]=0;
    for (i=1; i<=numhexen; i++) if (sprit[i].in_rect(sprit[0].ix,sprit[0].iy,32,32)) if (sprit[i].typ==gewaehlt) k=i;
    if (k>0)
    { if (main.soundon>0) main.zaund.play_sound(1);
      punkte=punkte+num/haeufigkeit[gewaehlt];
      sprit[k].off();
      add_hexe();
    }
    else
    { punkte=punkte-10;
      blitz_on=5;
      if (main.soundon>0) main.zaund.play_sound(2);
    }
   // Liste der aktiven Hexentypen, daraus eine wählen:
   for (i=1; i<=numhexen; i++) if (sprit[i].typ>0) { tli[0]++; tli[tli[0]]=sprit[i].typ; }
   k=rand.nextInt(tli[0])+1;
   gewaehlt=tli[k];
  }
 }

 void hover(int ix, int iy) { sprit[0].set_koords(ix-16,iy-16,999); }

 // neu help hiscore quit
 void startauswerten(int ix,int iy)
 { int h=main.gamepanel.symax/2-120;
   int b=main.gamepanel.sxmax/2-160;
   
   if (ix>b) if (ix<b+120) if (iy>h) if (iy<h+160);
   { if (iy<h+40) main.neu();
     else if (iy<h+80) main.show_hilfe();
     else if (iy<h+120) main.show_hsc();
     else main.aufraeumen();
   }
 }

}
