package hexentanz;

import javax.swing.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics2D.*;
import javax.imageio.*;
import java.io.*;
import gamelib.hiscore;


/**
Threadgesteuerte Darstellung eines Zeichenbrettes, benutzt Graphics2D.
Framerate ist derzeit 20ms.
*/

class spielfeld extends JPanel implements Runnable
{
  // alle "interessanten" Variable muessen statisch sein, sonst Nullpointer-exception!
  static final Color color_vg=new Color(192,192,248,255); // hellgraue Schrift
  static final Color color_vg2=new Color(255,240,0,191); // gold
  static final Color color_bg=new Color(0,0,48,191);      // dunkelblauer halbtransparenter Hintergrund
  static final Color color_rahmen=new Color(0,127,127,191); // tuerkiser Rahmen
  static final Font font=new Font("SansSerif",Font.BOLD,12);
  static final Font fonth=new Font("SansSerif",Font.BOLD,18);
  final FontMetrics metrics = getFontMetrics(font);
 // Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();

  static int sxmax=1600,symax=800,dx=96,dy=132,timetic=10; // maximale dim

  Thread refresh=null;
  long time2,time1=System.currentTimeMillis(); // Timer zu Testzwecken

  String bildpfad;
  Image titelima,bgima,pause,gover,crsr_32,hiscore,blitz;
  Image ima[]=new Image[50]; // Hexen, Geister
  
  
  // Background zum Zeichnen:
  BufferedImage bufima=new BufferedImage(sxmax,symax,BufferedImage.TYPE_INT_ARGB);
  Graphics gb=bufima.getGraphics(); // Reservebild ausserhalb screen

  int aktscreen=-1;                            // Titelbild
  int levelshown=-1;                           // kein level geladen
  // spiel p_game=main.game;  // Pointer auf Class Spiel, wird ueber die mama besorgt
  hiscore p_hsc=main.hsc; // Pointer auf Hiscore, mama lieferts
  // Leckerchen fuer Titelscreen:
  int select=0;
  int pos_goodie=0;
  int pos_goodie2=0;


/** Erzeugen eines Swing-kompatiblen Grafik-Canvasses.
@param parent aufrufende Klasse vom Typ main (Application)
*/
  public spielfeld(int size)
  { int i;
    bildpfad="/"+main.get_kennung()+"/images/";
    titelima=hole_bild(bildpfad+"titelbild.jpg");
    pause=hole_bild(bildpfad+"pause.png");
    gover=hole_bild(bildpfad+"gover.png");
    hiscore=hole_bild(bildpfad+"hiscore_titel.png");
    if (size>800) bgima=hole_bild(bildpfad+"saal_800.jpg");
    else bgima=hole_bild(bildpfad+"saal_400.jpg");
    crsr_32=hole_bild(bildpfad+"crsr_32.png");
    blitz=hole_bild(bildpfad+"blitz.jpg");
    for (i=0; i<45; i++)
     if (size>800) ima[i+1]=hole_bild(bildpfad+"hexe_"+i+".png");
     else ima[i+1]=hole_bild(bildpfad+"hexe_48_"+i+".gif");
    for (i=0; i<3; i++) ima[i+46]=hole_bild(bildpfad+"geist_"+(i+3)+".png");
 
    refresh=new Thread(this);
    refresh.start();
  }

/** Refresh-Loop */
  public void run()
  { while (refresh!=null)
    { repaint();
      try { Thread.sleep(timetic); }
      catch (InterruptedException e) { break; }
    }
  }
  // slots:
  public void stop()    { refresh=null; }
  public void destroy() { stop(); }

/** Wechsel zwischen Titelbild, Spielbrett, Hiscore und Hilfetexte */
  public void set_size(int ix) { sxmax=ix; symax=5*sxmax/8; int fac=1600/ix; dx=96/fac; dy=132/fac; }
 
  public void set_screen(String what)
  { if (what.equals("titel")) aktscreen=0;
    else if (what.equals("play")) aktscreen=1;
    else if (what.equals("help")) aktscreen=2;
    else if (what.equals("hiscore")) aktscreen=3;
    else aktscreen=0;
  }
  public String get_screen()
  { String t;
    switch(aktscreen)
    { case 1: t="play"; break;
      case 2: t="help"; break;
      case 3: t="hiscore"; break;
      default: t="titel";
    }
    return t;
  }
// ============================================================================================================

  public void paintComponent(Graphics g)
  { g.setColor(Color.black);
    g.fillRect(0,0,sxmax,sxmax);
    g.drawImage(bgima,0,0,sxmax,sxmax/2,null);
    g.setFont(font);
    switch(aktscreen)
    { case 0: zeige_titel(g); break;
      case 1: if (main.game.blitz_on>0) zeige_blitz(g); else mach_spielfeld(g); break;
      case 2: zeige_hilfe(g); break;
      case 3: zeige_hsc(g); break;
      default: zeige_titel(g);
    }
 //   time2=System.currentTimeMillis(); System.out.println((time2-time1)+"ms"); time1=time2;
  }

  Image hole_bild(String filnam)
  { Image im=null;
    try { im=ImageIO.read(getClass().getResource(filnam)); }
    catch(IOException io) { System.out.println(filnam+" not found or valid");   }
    return im;
  }

  void zeige_blitz(Graphics g)  {  g.drawImage(blitz,0,0,sxmax,sxmax/2,null); }

  void mach_spielfeld(Graphics g)
  { String out;
    sprite obj;
    int i,ih,ig=0;
    // Actionfeld:
    spiel p_game=main.game;
    int[] hf=new int[p_game.numtypen+1];
    for (i=0; i<=p_game.numtypen; i++) hf[i]=0;
    for (i=1; i<p_game.maxsprites; i++)
    { obj=p_game.sprit[p_game.liste[i]];
      if (obj.typ>p_game.numtypen) g.drawImage(ima[obj.typ],obj.ix,obj.iy,dx,dx,null);
      else if (obj.typ>0) { hf[obj.typ]++; ig++; g.drawImage(ima[obj.typ],obj.ix,obj.iy,dx,dy,null); }
    }
    // Anzeigen:
    obj=p_game.sprit[0];
    g.drawImage(crsr_32,obj.ix,obj.iy,32,32,null);
    if (p_game.gover) g.drawImage(gover,sxmax/2-gover.getWidth(this)/2,symax/2-gover.getHeight(this)/2,null);
    else if (p_game.pausiert) g.drawImage(pause,sxmax/2-pause.getWidth(this)/2,symax/2-pause.getHeight(this)/2,null);

    g.setColor(color_bg);
    g.fillRect(dx,sxmax/2,sxmax-2*dx,dx); // Statuszeile
    g.fillRect(0,symax-dy-50,dx+4,dy+4);
    g.setColor(color_vg);
    g.drawRect(0,symax-dy-50,dx+4,dy+4);
    g.setFont(font);
    if (p_game.gewaehlt>0)
    { g.drawImage(ima[p_game.gewaehlt],0,symax-dy-48,dx+2,dy,null); // gesuchte Hexe
      out=""+hf[p_game.gewaehlt]+" ";
      if (hf[p_game.gewaehlt]==1) out=out+main.langdef.get("WITCH"); else out=out+main.langdef.get("WITCHES");
      out=out+" "+main.langdef.get("VON")+" "+ig;
      g.drawString(out,dx+16,sxmax/2+12);
    }
    out=""+p_game.zeit+" "+main.langdef.get("RESTZEIT"); g.drawString(out,dx+16,sxmax/2+32);
    out=main.langdef.get("SCORE")+": "+p_game.punkte; g.drawString(out,4*dx,sxmax/2+12);
    out=p_game.messi; g.drawString(out,4*dx,sxmax/2+32);
  }

  void zeige_hsc(Graphics g)
  { int i,k=sxmax/2-240,line,max,breite=480;
    p_hsc=main.hsc; // diskreter Hiscore
    max=p_hsc.get_len();
    String out;
    g.drawImage(bgima,0,0,null);
    g.drawImage(hiscore,k,48,null); // Titel

    // g.setFont(fonth);
    g.setColor(color_bg); g.fillRect(k,96,breite,max*24+64);
    line=120;
    g.setColor(color_vg2);
    out=main.langdef.get("RANG"); g.drawString(out,k+16,line);
    out=main.langdef.get("SCORE"); g.drawString(out,k+breite/2-metrics.stringWidth(out),line);
    out=main.langdef.get("DATE"); g.drawString(out,k+breite-24-metrics.stringWidth(out),line);
    g.drawLine(k,line+8,k+breite,line+8);
    
    g.setColor(color_rahmen);
    g.drawRect(k,96,breite,max*24+64);
    g.drawRect(k-2,96-2,breite,max*24+64);
    g.drawRect(k-4,96-4,breite,max*24+64);

    g.setColor(color_vg);
    line=156;
    for (i=0; i<max; i++)
    { g.drawString(""+(i+1)+". "+p_hsc.get_snamen(i),k+16,line);
      out=""+p_hsc.get_punkte(i); g.drawString(out,k+breite/2-metrics.stringWidth(out),line);
      out=p_hsc.get_datum(i);     g.drawString(out,k+breite-24-metrics.stringWidth(out),line);
      line=line+24;
    }
  }

  void zeige_hilfe(Graphics g)
  { int offx=sxmax/2-320;
    g.setColor(color_bg);     g.fillRect(offx,0,616,320);
    g.setColor(color_rahmen); g.drawRect(offx,0,616,320);
    g.setColor(color_vg); g.setFont(fonth); g.drawString(main.hilfetext[0],offx+64,32);
    g.drawLine(32,48,sxmax-32,48);
    g.setFont(font);
    for (int i=1; i<main.hilfetext.length; i++) g.drawString(main.hilfetext[i],offx+12,80+16*i);
  }

  void zeige_titel(Graphics g)
  { int x0,y0;
    x0=sxmax/2-160; y0=symax/2-120;
    g.setColor(color_bg);
    g.fillOval(x0,y0,320,40);
    g.fillOval(x0,y0+40,320,40);
    g.fillOval(x0,y0+80,320,40);
    g.fillOval(x0,y0+120,320,40);
    x0=x0+80; y0=y0+20;
    g.setColor(color_vg);
    g.drawString(main.langdef.get("NEW")+": Ctrl-N",x0,y0);
    g.drawString(main.langdef.get("HELP")+": Ctrl-H",x0,y0+40);
    g.drawString(main.langdef.get("HISCORE")+": Ctrl-B",x0,y0+80);
    g.drawString(main.langdef.get("QUIT")+": Ctrl-Q",x0,y0+120);
  }
}